:: CreateMgaXmpFiles.bat
::	- Create GME .Mga and .Xmp files by importing .Xme file
::
:: Arguments:
::	-none
::
:: Requirements:
::	Environment variable GREAT_PATH must be set to the local GReAT root folder
::

REM	Meta/
REM	* GReATConfig.mga
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Meta\GReATConfig_meta.xme" "%GREAT_PATH%\Meta\GReATConfig.mga" MetaGME
REM 	* GReATConfig.xmp
	cd /d %GREAT_PATH%\Meta
	call "%GREAT_PATH%\Release\CreateXmp.vbs" "%GREAT_PATH%\Meta\GReATConfig.mga"
REM	* UmlModelTransformer.mga
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Meta\UmlModelTransformer_meta.xme" "%GREAT_PATH%\Meta\UmlModelTransformer.mga" MetaGME
REM 	UmlModelTransformer.xmp
	cd /d %GREAT_PATH%\Meta
	call "%GREAT_PATH%\Release\CreateXmp.vbs" "%GREAT_PATH%\Meta\UmlModelTransformer.mga"
REM	Samples/
REM	* House2Order.mga
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\House2Order\House2Order.xme" "%GREAT_PATH%\Samples\House2Order\House2Order.mga" UMLModelTransformer
REM	* HouseModel.mga
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\House2Order\Meta\HouseModel_meta.xme" "%GREAT_PATH%\Samples\House2Order\Meta\HouseModel.mga" MetaGME
REM	* GS_HouseModel.xmp
	cd /d %GREAT_PATH%\Samples\House2Order\Meta
	call "%GREAT_PATH%\Release\CreateXmp.vbs" "%GREAT_PATH%\Samples\House2Order\Meta\HouseModel.mga"
REM	* Order.mga
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\House2Order\Meta\Order_meta.xme" "%GREAT_PATH%\Samples\House2Order\Meta\Order.mga" MetaGME
REM	* GS_Order.xmp
	cd /d %GREAT_PATH%\Samples\House2Order\Meta
	call "%GREAT_PATH%\Release\CreateXmp.vbs" "%GREAT_PATH%\Samples\House2Order\Meta\Order.mga"
REM	* myHouse1.mga
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\House2Order\Models\myHouse1.xme" "%GREAT_PATH%\Samples\House2Order\Models\myHouse1.mga" GS_HouseModel
    call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\House2Order\Models\correct_myOrder1_model.xme" "%GREAT_PATH%\Samples\House2Order\Models\correct_myOrder1_model.mga" GS_Order
REM	* SignalFlow2FlatSF.mga
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\SignalFlow2FlatSF\SignalFlow2FlatSF.xme" "%GREAT_PATH%\Samples\SignalFlow2FlatSF\SignalFlow2FlatSF.mga" UMLModelTransformer
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\SignalFlow2FlatSF\SignalFlow2FlatSF_test_globalObject.xme" "%GREAT_PATH%\Samples\SignalFlow2FlatSF\SignalFlow2FlatSF_test_globalObject.mga" UMLModelTransformer
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\SignalFlow2FlatSF\SignalFlow2FlatSF_test_sortingFunc.xme" "%GREAT_PATH%\Samples\SignalFlow2FlatSF\SignalFlow2FlatSF_test_sortingFunc.mga" UMLModelTransformer
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\SignalFlow2FlatSF\SignalFlow_test_distinguished.xme" "%GREAT_PATH%\Samples\SignalFlow2FlatSF\SignalFlow_test_distinguished.mga" UMLModelTransformer
REM	* FlatSF.mga
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\SignalFlow2FlatSF\Meta\FlatSF\FlatSF_meta.xme" "%GREAT_PATH%\Samples\SignalFlow2FlatSF\Meta\FlatSF\FlatSF.mga" MetaGME
REM	* GS_FlatSF.xmp
	cd /d %GREAT_PATH%\Samples\SignalFlow2FlatSF\Meta\FlatSF
	call "%GREAT_PATH%\Release\CreateXmp.vbs" "%GREAT_PATH%\Samples\SignalFlow2FlatSF\Meta\FlatSF\FlatSF.mga"
REM	* SignalFlow.mga
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\SignalFlow2FlatSF\Meta\SignalFlow\SignalFlow_meta.xme" "%GREAT_PATH%\Samples\SignalFlow2FlatSF\Meta\SignalFlow\SignalFlow.mga" MetaGME
REM	* GS_SignalFlow.xmp
	cd /d %GREAT_PATH%\Samples\SignalFlow2FlatSF\Meta\SignalFlow
	call "%GREAT_PATH%\Release\CreateXmp.vbs" "%GREAT_PATH%\Samples\SignalFlow2FlatSF\Meta\SignalFlow\SignalFlow.mga"
REM	* SignalFlow_1.mga, ..., SignalFlow_7.mga,  SignalFlow_to_connect.mga
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\SignalFlow2FlatSF\Models\SignalFlow_1.xme" "%GREAT_PATH%\Samples\SignalFlow2FlatSF\Models\SignalFlow_1.mga" GS_SignalFlow
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\SignalFlow2FlatSF\Models\SignalFlow_2.xme" "%GREAT_PATH%\Samples\SignalFlow2FlatSF\Models\SignalFlow_2.mga" GS_SignalFlow
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\SignalFlow2FlatSF\Models\SignalFlow_3.xme" "%GREAT_PATH%\Samples\SignalFlow2FlatSF\Models\SignalFlow_3.mga" GS_SignalFlow
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\SignalFlow2FlatSF\Models\SignalFlow_4.xme" "%GREAT_PATH%\Samples\SignalFlow2FlatSF\Models\SignalFlow_4.mga" GS_SignalFlow
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\SignalFlow2FlatSF\Models\SignalFlow_5.xme" "%GREAT_PATH%\Samples\SignalFlow2FlatSF\Models\SignalFlow_5.mga" GS_SignalFlow
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\SignalFlow2FlatSF\Models\SignalFlow_6.xme" "%GREAT_PATH%\Samples\SignalFlow2FlatSF\Models\SignalFlow_6.mga" GS_SignalFlow
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\SignalFlow2FlatSF\Models\SignalFlow_7.xme" "%GREAT_PATH%\Samples\SignalFlow2FlatSF\Models\SignalFlow_7.mga" GS_SignalFlow
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\SignalFlow2FlatSF\Models\SignalFlow_to_connect.xme" "%GREAT_PATH%\Samples\SignalFlow2FlatSF\Models\SignalFlow_to_connect.mga" GS_SignalFlow
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\SignalFlow2FlatSF\Models\correct_SignalFlow_connected.xme" "%GREAT_PATH%\Samples\SignalFlow2FlatSF\Models\correct_SignalFlow_connected.mga" GS_SignalFlow
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\SignalFlow2FlatSF\Models\correct_OutFSF1.xme" "%GREAT_PATH%\Samples\SignalFlow2FlatSF\Models\correct_OutFSF1.mga" GS_FlatSF
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\SignalFlow2FlatSF\Models\correct_OutFSF_testSorting.xme" "%GREAT_PATH%\Samples\SignalFlow2FlatSF\Models\correct_OutFSF_testSorting.mga" GS_FlatSF
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\SignalFlow2FlatSF\Models\correct_OutFSF_testGO.xme" "%GREAT_PATH%\Samples\SignalFlow2FlatSF\Models\correct_OutFSF_testGO.mga" GS_FlatSF
REM	* HSM2FSM.mga
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\StateChart\HSM2FSM.xme" "%GREAT_PATH%\Samples\StateChart\HSM2FSM.mga" UMLModelTransformer
REM	* FiniteStateMachine.mga
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\StateChart\Meta\FiniteStateMachine_meta.xme" "%GREAT_PATH%\Samples\StateChart\Meta\FiniteStateMachine.mga" MetaGME
REM	* GS_FiniteStateMachine.xmp
	cd /d %GREAT_PATH%\Samples\StateChart\Meta
	call "%GREAT_PATH%\Release\CreateXmp.vbs" "%GREAT_PATH%\Samples\StateChart\Meta\FiniteStateMachine.mga"
REM	* StateChart.mga
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\StateChart\Meta\StateChart_meta.xme" "%GREAT_PATH%\Samples\StateChart\Meta\StateChart.mga" MetaGME
REM	* GS_StateChart.xmp
	cd /d %GREAT_PATH%\Samples\StateChart\Meta
	call "%GREAT_PATH%\Release\CreateXmp.vbs" "%GREAT_PATH%\Samples\StateChart\Meta\StateChart.mga"
REM	* 2BitCounter.mga, 3BitCounter.mga
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\StateChart\Models\2BitCounter.xme" "%GREAT_PATH%\Samples\StateChart\Models\2BitCounter.mga" GS_StateChart
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\StateChart\Models\3BitCounter.xme" "%GREAT_PATH%\Samples\StateChart\Models\3BitCounter.mga" GS_StateChart
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\StateChart\Models\correct_2Bit_OutSC.xme" "%GREAT_PATH%\Samples\StateChart\Models\correct_2Bit_OutSC.mga" GS_StateChart
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\StateChart\Models\correct_3Bit_OutSC.xme" "%GREAT_PATH%\Samples\StateChart\Models\correct_3Bit_OutSC.mga" GS_StateChart
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\StateChart\Models\correct_2Bit_OutFSM.xme" "%GREAT_PATH%\Samples\StateChart\Models\correct_2Bit_OutFSM.mga" GS_FiniteStateMachine
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\StateChart\Models\correct_3Bit_OutFSM.xme" "%GREAT_PATH%\Samples\StateChart\Models\correct_3Bit_OutFSM.mga" GS_FiniteStateMachine

REM	* BidirectAssoc.mga
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\MatchAnyAssoc\meta\BidirectAssoc.xme" "%GREAT_PATH%\Samples\MatchAnyAssoc\meta\BidirectAssoc.mga" MetaGME
REM	* GS_BidirectAssoc.xmp
	cd /d %GREAT_PATH%\Samples\MatchAnyAssoc\Meta
	call "%GREAT_PATH%\Release\CreateXmp.vbs" "%GREAT_PATH%\Samples\MatchAnyAssoc\Meta\BidirectAssoc.mga"
REM	* BidirectAssoc_mode.mga
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\MatchAnyAssoc\models\BidirectAssoc_model.xme" "%GREAT_PATH%\Samples\MatchAnyAssoc\models\BidirectAssoc_model.mga" GS_BidirectAssoc
REM	* testMatchAnyAssoc.mga
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\MatchAnyAssoc\testMatchAnyAssoc.xme" "%GREAT_PATH%\Samples\MatchAnyAssoc\testMatchAnyAssoc.mga" UMLModelTransformer

REM 	* MoveSignalFlowGroup.mga
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\SignalFlowGroup\MoveSignalFlowGroup.xme" "%GREAT_PATH%\Samples\SignalFlowGroup\MoveSignalFlowGroup.mga" UMLModelTransformer
REM	* GS_SignalFlowGroup.mga
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\SignalFlowGroup\Meta\GS_SignalFlowGroup.xme" "%GREAT_PATH%\Samples\SignalFlowGroup\Meta\GS_SignalFlowGroup.mga" MetaGME
REM	* GS_SignalFlowGroup.xmp
	cd /d %GREAT_PATH%\Samples\SignalFlowGroup\Meta
	call "%GREAT_PATH%\Release\CreateXmp.vbs" "%GREAT_PATH%\Samples\SignalFlowGroup\Meta\GS_SignalFlowGroup.mga"
REM	* mySignalFlow1.mga
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\SignalFlowGroup\Models\mySignalFlow1.xme" "%GREAT_PATH%\Samples\SignalFlowGroup\Models\mySignalFlow1.mga" GS_SignalFlowGroup
REM	* correct_SignalFlowGroup.mga
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\SignalFlowGroup\Models\correct_SignalFlowGroup.xme" "%GREAT_PATH%\Samples\SignalFlowGroup\Models\correct_SignalFlowGroup.mga" GS_SignalFlowGroup
REM 	* Go back to GREAT_PATH
	cd /d %GREAT_PATH%

REM	* ex3.mga	
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\GroupSample_1\ex3.xme" "%GREAT_PATH%\Samples\GroupSample_1\ex3.mga" UMLModelTransformer
REM	* mm1.mga
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\GroupSample_1\Meta\mm1.xme" "%GREAT_PATH%\Samples\GroupSample_1\Meta\mm1.mga" MetaGME
REM	* mm1.xmp
	cd /d %GREAT_PATH%\Samples\GroupSample_1\Meta
	call "%GREAT_PATH%\Release\CreateXmp.vbs" "%GREAT_PATH%\Samples\GroupSample_1\Meta\mm1.mga"
REM	* mm1_input_small.mga
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\GroupSample_1\Models\mm1_input_small.xme" "%GREAT_PATH%\Samples\GroupSample_1\Models\mm1_input_small.mga" mm1
REM	* correct_mm1_output_small.mga
	call "%GREAT_PATH%\Release\CreateMGA.vbs" "%GREAT_PATH%\Samples\GroupSample_1\Models\correct_mm1_output_small.xme" "%GREAT_PATH%\Samples\GroupSample_1\Models\correct_mm1_output_small.mga" mm1
