/* NAME:	RuleTypes
 * AUTHOR:	Attila Vizhanyo - viza@isis-server.isis.vanderbilt.edu
 *
 * Some common std::string constans for code generation.
 */
#ifndef __PESTRINGTABLE_H
#define __PESTRINGTABLE_H

#ifdef _MSC_VER
#pragma warning (disable : 4786)
#pragma warning (disable : 4503) 
#endif

#include <string>

const std::string SEP= " ";	// separator 
const std::string CST= "const";	// const
const std::string REF= "&";	// reference
const std::string PTR= "*";	// pointer
const std::string RES= "::";	// resolutor
const std::string ACC= "->";	// accessor
const std::string EQ= "=";	// equal
const std::string EQEQ= "==";	// equal equal
const std::string NEQ= "!=";	// not equal
const std::string PEQ= "+=";	// plus equal
const std::string MEQ= "-=";	// minus equal
const std::string INC= "++";	// increment
const std::string DEC= "--";	// decrement
const std::string PKS= "Packets_t";
const std::string BEG= "begin()";
const std::string END= "end()";
const std::string CIT= "const_iterator";
const std::string IT= "it";
const std::string CURR= "curr";
const std::string TRU= "true";
const std::string FAL= "false";
const std::string BOL= "bool";
const std::string RET= "return";
const std::string CURRM= "currMatch";
const std::string MATCH= "Match";
const std::string _MATCHES= "_matches";
const std::string UNQ= "isUnique";
const std::string ISMATCH= "isMatch";

#endif //__PESTRINGTABLE_H