#if !defined(AFX_GRENGINEDLGDLG_H__74FDFC5D_C71E_4431_82C4_B8289FB6FB14__INCLUDED_)
#define AFX_GRENGINEDLGDLG_H__74FDFC5D_C71E_4431_82C4_B8289FB6FB14__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// GREngineDlgDlg.h : header file
//

#include "resource.h"
#include "IGReAT.h"

/////////////////////////////////////////////////////////////////////////////
// CGREngineDlgDlg dialog
#define SET_PROGRESS (WM_USER+1)
#define GR_FINISHED (WM_USER+2)
#define SET_EXECUTERULE (WM_USER+3)

class Notify;

namespace boost
{
  class thread;
}

class CGREngineDlgDlg : public CDialog
{
protected:
  Notify*         m_notify;
  boost::thread*  m_thrd; 
  CProgressCtrl* m_prg; 
  UINT m_maxPrg;
  bool m_finished;

  string cfgPath;
  vector<string> cfgInputs;

  int processPos;

// Construction
public:
  LRESULT OnProgress(WPARAM wp, LPARAM lp);
  LRESULT OnFinished(WPARAM wp, LPARAM lp);
  LRESULT OnExecuteRule(WPARAM wp, LPARAM lp);


	CGREngineDlgDlg(CWnd* pParent = NULL);   // standard constructor
	CGREngineDlgDlg(const string &filePath, CWnd* pParent = NULL); 
	CGREngineDlgDlg(const string &filePath, const vector<string> &inputs, CWnd* pParent = NULL);   

	static string outputMsg;
// Dialog Data
	//{{AFX_DATA(CGREngineDlgDlg)
	enum { IDD = IDD_GREPROCESS_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGREngineDlgDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void PostNcDestroy();
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CGREngineDlgDlg)
	virtual void OnCancel();
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GRENGINEDLGDLG_H__74FDFC5D_C71E_4431_82C4_B8289FB6FB14__INCLUDED_)
