#include <string>
#include <stdlib.h>


template <class T>
bool XPosCmp( const T& lhs, const T& rhs) {
	std::string lhs_pos= lhs.position();
std::string rhs_pos= rhs.position();

std::string::size_type findTrans = lhs_pos.find("Transform");
lhs_pos = lhs_pos.substr(findTrans);
std::cout << "Now lhs_pos = " << lhs_pos << std::endl;
findTrans = lhs_pos.find("(");
lhs_pos = lhs_pos.substr(findTrans+1);
lhs_pos = lhs_pos.substr(0,lhs_pos.size()-2);
std::cout << "After trim lhs_pos = " << lhs_pos << std::endl;
findTrans = lhs_pos.find(',');
int lhs_x = atoi(lhs_pos.substr(0,findTrans).c_str());

findTrans = rhs_pos.find("Transform");
rhs_pos = rhs_pos.substr(findTrans);
findTrans = rhs_pos.find("(");
rhs_pos = rhs_pos.substr(findTrans+1);
rhs_pos = rhs_pos.substr(0, rhs_pos.size()-2);
findTrans = rhs_pos.find(',');
int rhs_x = atoi(rhs_pos.substr(0,findTrans).c_str());

std::cout << "LHSX = " << lhs_x << " and RHSX = " << rhs_x << std::endl;

return (lhs_x<rhs_x);
}

template <class BASE, class T>
bool XPosCmp_caster( const BASE& lhs, const BASE& rhs) {
	T lhs_casted= T::Cast( lhs);
	T rhs_casted= T::Cast( rhs);
	return XPosCmp( lhs_casted, rhs_casted);
}

template <class T>
bool YPosCmp( const T& lhs, const T& rhs) {
	std::string lhs_pos= lhs.position();
	std::string rhs_pos= rhs.position();
std::cout << "LHS Position is: " << lhs_pos<< std::endl;
	// strip leading '<' & trailing '>'
	lhs_pos= lhs_pos.substr( 1, lhs_pos.size()-2);
	rhs_pos= rhs_pos.substr( 1, rhs_pos.size()-2);
	std::string::size_type findComma= lhs_pos.find( ',');
	int lhs_x= atoi( lhs_pos.substr(0, findComma).c_str());
	int lhs_y= atoi( lhs_pos.substr(findComma+1, lhs_pos.size()- (findComma+1)).c_str());
	findComma= rhs_pos.find( ',');
	int rhs_x= atoi( rhs_pos.substr(0, findComma).c_str());
	int rhs_y= atoi( rhs_pos.substr(findComma+1, rhs_pos.size()- (findComma+1)).c_str());
	
	return ( lhs_y < rhs_y);
}

template <class BASE, class T>
bool YPosCmp_caster( const BASE& lhs, const BASE& rhs) {
	T lhs_casted= T::Cast( lhs);
	T rhs_casted= T::Cast( rhs);
	return YPosCmp( lhs_casted, rhs_casted);
}

template <typename T> int GetCoord(const T& ob, bool YCoord=true)
{
	std::string ob_pos= ob.position();
	std::string::size_type findTrans= ob_pos.find("Transform");
	ob_pos = ob_pos.substr(findTrans+10); //Transform(x,y);
	ob_pos = ob_pos.substr(0,ob_pos.size()-2); //Transform(x,y);
	std::string::size_type findComma= ob_pos.find( ',');
	int lhs_x= atoi( ob_pos.substr(0, findComma).c_str());
	int lhs_y= atoi( ob_pos.substr(findComma+1, ob_pos.size()- (findComma+1)).c_str());

	if(YCoord)
		return lhs_y;

	return lhs_x;
}

template <typename T> void SetXCoord(T& ob, int xPos)
{
	int y = GetCoord(ob);

	char yBuf[5], xBuf[5];
	_itoa_s(y,yBuf,10);
	std::string yStr(yBuf);
	_itoa_s(xPos, xBuf, 10);
	std::string xStr(xBuf);

	std::string newPos = "Template(";
	newPos.append("-1");
	newPos.append(",");
	newPos.append("-1");
	newPos.append(");Transform(");
	newPos.append(xStr);
	newPos.append(",");
	newPos.append(yStr);
	newPos.append(");");
	
	ob.position() = newPos;
}

template <typename T> void SetCoord(T& ob, int xPos, int yPos)
{
	char yBuf[5], xBuf[5];
	for(int j=0;j<5;++j)
	{
		yBuf[j] = '\0';
		xBuf[j] = '\0';
	}
	_itoa_s(yPos,yBuf,10);
	std::string yStr(yBuf);
	_itoa_s(xPos, xBuf, 10);
	std::string xStr(xBuf);

	std::string newPos = "Template(";
	newPos.append("-1");
	newPos.append(",");
	newPos.append("-1");
	newPos.append(");Transform(");
	newPos.append(xStr);
	newPos.append(",");
	newPos.append(yStr);
	newPos.append(");");
	
	ob.position() = newPos;
}

