/* GenMyTransform.cpp generated on Fri Nov 04 00:47:42 2005
 */

#include "GenMyTransform.h"
#include <UmlExt.h>
#include <UdmUtil.h>
#include "GReATSort.h"
#include "MyTransform-gr_cmptempl.h"

using namespace std;

void TopBlock_0::operator()( const Packets_t& ins_1)
{
#ifdef PRINT_INFO
	std::cout << "TopBlock_0" << std::endl;
#endif
	if( ( !ins_1.empty()))
		callGetCompoundRules_95( ins_1);
}

void TopBlock_0::callGetCompoundRules_95( const Packets_t& rootFolders_4)
{
	Packets_t compoundRules_6;
	GetCompoundRules_3 getCompoundRules_3;
	getCompoundRules_3( rootFolders_4, compoundRules_6);
	if( ( !compoundRules_6.empty()))
		callGetRules_97( compoundRules_6);
}

void TopBlock_0::callGetRules_97( const Packets_t& compoundRules_76)
{
	Packets_t froms_78;
	Packets_t tos_79;
	GetRules_75 getRules_75;
	getRules_75( compoundRules_76, froms_78, tos_79);
	if( ( !froms_78.empty())&& ( !tos_79.empty()))
		callBlock_99( froms_78, tos_79);
}

void TopBlock_0::callBlock_99( const Packets_t& ins_1d, const Packets_t& ins_1f)
{
	Block_1c block_1c;
	block_1c( ins_1d, ins_1f);
}

void GetCompoundRules_3::operator()( const Packets_t& rootFolders_4, Packets_t& compoundRules_6)
{
#ifdef PRINT_INFO
	std::cout << "GetCompoundRules_3" << std::endl;
#endif
	_compoundRule_7= &compoundRules_6;
	processInputPackets( rootFolders_4);
}

bool GetCompoundRules_3::isInputUnique( const Udm::Object& rootFolder_c)
{
	bool isUnique= true;
	for( Packets_t::const_iterator itRootFolder_e= _rootFolder_8.begin(); itRootFolder_e!= _rootFolder_8.end(); ++itRootFolder_e)
	{
		if( ( *itRootFolder_e== rootFolder_c))
		{
			isUnique= false;
			break;
		}
	}
	if( isUnique)
		_rootFolder_8.push_back( rootFolder_c);
	return isUnique;
}

void GetCompoundRules_3::processInputPackets( const Packets_t& rootFolders_4)
{
	for( Packets_t::const_iterator itRootFolder_9= rootFolders_4.begin(); itRootFolder_9!= rootFolders_4.end(); ++itRootFolder_9)
	{
		bool isUnique= isInputUnique( *itRootFolder_9);
		if( !isUnique)
			continue;
		bool isMatch= patternMatcher( *itRootFolder_9);
		if( isMatch)
			effector( );
		_matches.clear();
	}
}

bool GetCompoundRules_3::patternMatcher( const Udm::Object& rootFolder_a)
{
	for( int i= 0; i< 1; ++i)
	{
		if( false== Uml::IsDerivedFrom( rootFolder_a.type(), UMLModelTransformer::RootFolder::meta))
			continue;
		UMLModelTransformer::RootFolder rootFolder_f= UMLModelTransformer::RootFolder::Cast( rootFolder_a);
		set< UMLModelTransformer::Transformation> transformations_11= rootFolder_f.Transformation_kind_children();
		for( set< UMLModelTransformer::Transformation>::const_iterator itTransformation_12= transformations_11.begin(); itTransformation_12!= transformations_11.end(); ++itTransformation_12)
		{
			UMLModelTransformer::Transformation currTransformation_13= *itTransformation_12;
			set< UMLModelTransformer::CompoundRule> compoundRules_14= currTransformation_13.CompoundRule_kind_children();
			for( set< UMLModelTransformer::CompoundRule>::const_iterator itCompoundRule_15= compoundRules_14.begin(); itCompoundRule_15!= compoundRules_14.end(); ++itCompoundRule_15)
			{
				UMLModelTransformer::CompoundRule currCompoundRule_16= *itCompoundRule_15;
				Match currMatch;
				currMatch.rootFolder_17= rootFolder_f;
				currMatch.transformation_18= currTransformation_13;
				currMatch.compoundRule_19= currCompoundRule_16;
				_matches.push_back( currMatch);
			}
		}
	}
	return !_matches.empty();
}

void GetCompoundRules_3::effector()
{
	for( std::list< Match>::const_iterator itMatch= _matches.begin(); itMatch!= _matches.end(); ++itMatch)
	{
		Match currMatch= *itMatch;
		outputAppender( currMatch.compoundRule_19);
	}
}

void GetCompoundRules_3::outputAppender( const UMLModelTransformer::CompoundRule& compoundRule_1a)
{
	_compoundRule_7->push_back( compoundRule_1a);
}

void Block_1c::operator()( const Packets_t& ins_1d, const Packets_t& ins_1f)
{
#ifdef PRINT_INFO
	std::cout << "Block_1c" << std::endl;
#endif
	if( ( !ins_1d.empty())&& ( !ins_1f.empty()))
		callGetPorts_6f( ins_1d, ins_1f);
}

void Block_1c::callGetPorts_6f( const Packets_t& expressions_46, const Packets_t& expressions_48)
{
	Packets_t outs_45;
	Packets_t ins_4a;
	GetPorts_44 getPorts_44;
	getPorts_44( expressions_46, expressions_48, outs_45, ins_4a);
	if( ( !outs_45.empty())&& ( !ins_4a.empty()))
		callConnectPorts_72( outs_45, ins_4a);
}

void Block_1c::callConnectPorts_72( const Packets_t& outs_22, const Packets_t& ins_24)
{
	ConnectPorts_21 connectPorts_21;
	connectPorts_21( outs_22, ins_24);
}

void ConnectPorts_21::operator()( const Packets_t& outs_22, const Packets_t& ins_24)
{
#ifdef PRINT_INFO
	std::cout << "ConnectPorts_21" << std::endl;
#endif
	processInputPackets( outs_22, ins_24);
}

bool ConnectPorts_21::isInputUnique( const Udm::Object& out_2a, const Udm::Object& in_33)
{
	bool isUnique= true;
	for( Packets_t::const_iterator itOut_2c= _out_26.begin(), itIn_35= _in_2f.begin(); itOut_2c!= _out_26.end(), itIn_35!= _in_2f.end(); ++itOut_2c, ++itIn_35)
	{
		if( ( *itOut_2c== out_2a)&& ( *itIn_35== in_33))
		{
			isUnique= false;
			break;
		}
	}
	if( isUnique)
	{
		_out_26.push_back( out_2a);
		_in_2f.push_back( in_33);
	}
	return isUnique;
}

void ConnectPorts_21::processInputPackets( const Packets_t& outs_22, const Packets_t& ins_24)
{
	for( Packets_t::const_iterator itOut_27= outs_22.begin(), itIn_30= ins_24.begin(); itOut_27!= outs_22.end(), itIn_30!= ins_24.end(); ++itOut_27, ++itIn_30)
	{
		bool isUnique= isInputUnique( *itOut_27, *itIn_30);
		if( !isUnique)
			continue;
		bool isMatch= patternMatcher( *itOut_27, *itIn_30);
		if( isMatch)
			effector( );
		_matches.clear();
	}
}

bool ConnectPorts_21::patternMatcher( const Udm::Object& out_28, const Udm::Object& in_31)
{
	for( int i= 0; i< 1; ++i)
	{
		if( false== Uml::IsDerivedFrom( out_28.type(), UMLModelTransformer::Out::meta))
			continue;
		UMLModelTransformer::Out out_2d= UMLModelTransformer::Out::Cast( out_28);
		if( false== Uml::IsDerivedFrom( in_31.type(), UMLModelTransformer::In::meta))
			continue;
		UMLModelTransformer::In in_36= UMLModelTransformer::In::Cast( in_31);
		Udm::Object inParent_38= in_36.container();
		if( false== Uml::IsDerivedFrom( inParent_38.type(), UMLModelTransformer::Expression::meta))
			continue;
		UMLModelTransformer::Expression expressionIn_39= UMLModelTransformer::Expression::Cast( inParent_38);
		Udm::Object expressionParent_3a= expressionIn_39.container();
		if( false== Uml::IsDerivedFrom( expressionParent_3a.type(), UMLModelTransformer::Expression::meta))
			continue;
		UMLModelTransformer::Expression expressionExpression_3b= UMLModelTransformer::Expression::Cast( expressionParent_3a);
		Udm::Object outParent_3c= out_2d.container();
		if( false== Uml::IsDerivedFrom( outParent_3c.type(), UMLModelTransformer::Expression::meta))
			continue;
		UMLModelTransformer::Expression expressionOut_3d= UMLModelTransformer::Expression::Cast( outParent_3c);
		Match currMatch;
		currMatch.out_3e= out_2d;
		currMatch.expression_3f= expressionOut_3d;
		currMatch.expression_40= expressionIn_39;
		currMatch.expression_41= expressionExpression_3b;
		currMatch.in_42= in_36;
		_matches.push_back( currMatch);
	}
	return !_matches.empty();
}

void ConnectPorts_21::effector()
{
	for( std::list< Match>::const_iterator itMatch= _matches.begin(); itMatch!= _matches.end(); ++itMatch)
	{
		Match currMatch= *itMatch;
		UMLModelTransformer::Sequence newSequence_43= UMLModelTransformer::Sequence::Create( currMatch.expression_41);
		newSequence_43.srcSequence_end()= currMatch.out_3e;
		newSequence_43.dstSequence_end()= currMatch.in_42;
	}
}

void GetPorts_44::operator()( const Packets_t& expressions_46, const Packets_t& expressions_48, Packets_t& outs_45, Packets_t& ins_4a)
{
#ifdef PRINT_INFO
	std::cout << "GetPorts_44" << std::endl;
#endif
	_out_4b= &outs_45;
	_in_4c= &ins_4a;
	processInputPackets( expressions_46, expressions_48);
	distinguishedSortOutputs( );
}

bool GetPorts_44::isInputUnique( const Udm::Object& expression_51, const Udm::Object& expression_5a)
{
	bool isUnique= true;
	for( Packets_t::const_iterator itExpression_53= _expression_4d.begin(), itExpression_5c= _expression_56.begin(); itExpression_53!= _expression_4d.end(), itExpression_5c!= _expression_56.end(); ++itExpression_53, ++itExpression_5c)
	{
		if( ( *itExpression_53== expression_51)&& ( *itExpression_5c== expression_5a))
		{
			isUnique= false;
			break;
		}
	}
	if( isUnique)
	{
		_expression_4d.push_back( expression_51);
		_expression_56.push_back( expression_5a);
	}
	return isUnique;
}

void GetPorts_44::processInputPackets( const Packets_t& expressions_46, const Packets_t& expressions_48)
{
	for( Packets_t::const_iterator itExpression_4e= expressions_46.begin(), itExpression_57= expressions_48.begin(); itExpression_4e!= expressions_46.end(), itExpression_57!= expressions_48.end(); ++itExpression_4e, ++itExpression_57)
	{
		bool isUnique= isInputUnique( *itExpression_4e, *itExpression_57);
		if( !isUnique)
			continue;
		bool isMatch= patternMatcher( *itExpression_4e, *itExpression_57);
		if( isMatch)
			effector( );
		_matches.clear();
	}
}

bool GetPorts_44::patternMatcher( const Udm::Object& expression_4f, const Udm::Object& expression_58)
{
	for( int i= 0; i< 1; ++i)
	{
		if( false== Uml::IsDerivedFrom( expression_4f.type(), UMLModelTransformer::Expression::meta))
			continue;
		UMLModelTransformer::Expression expression_54= UMLModelTransformer::Expression::Cast( expression_4f);
		if( false== Uml::IsDerivedFrom( expression_58.type(), UMLModelTransformer::Expression::meta))
			continue;
		UMLModelTransformer::Expression expression_5d= UMLModelTransformer::Expression::Cast( expression_58);
		set< UMLModelTransformer::In> ins_5f= expression_5d.In_kind_children();
		for( set< UMLModelTransformer::In>::const_iterator itIn_60= ins_5f.begin(); itIn_60!= ins_5f.end(); ++itIn_60)
		{
			UMLModelTransformer::In currIn_61= *itIn_60;
			set< UMLModelTransformer::Out> outs_62= expression_54.Out_kind_children();
			for( set< UMLModelTransformer::Out>::const_iterator itOut_63= outs_62.begin(); itOut_63!= outs_62.end(); ++itOut_63)
			{
				UMLModelTransformer::Out currOut_64= *itOut_63;
				Match currMatch;
				currMatch.out_65= currOut_64;
				currMatch.expression_66= expression_54;
				currMatch.expression_67= expression_5d;
				currMatch.in_68= currIn_61;
				_matches.push_back( currMatch);
			}
		}
	}
	return !_matches.empty();
}

void GetPorts_44::effector()
{
	for( std::list< Match>::const_iterator itMatch= _matches.begin(); itMatch!= _matches.end(); ++itMatch)
	{
		Match currMatch= *itMatch;
		outputAppender( currMatch.out_65, currMatch.in_68);
	}
}

void GetPorts_44::outputAppender( const UMLModelTransformer::Out& out_69, const UMLModelTransformer::In& in_6b)
{
	_out_4b->push_back( out_69);
	_in_4c->push_back( in_6b);
}

template< class T>
void deleteFrom( T* container, unsigned int from) {
	T::iterator delFrom= container->begin();
	while ( from--) {
		++delFrom;
	}
	container->erase( delFrom, container->end());
}

void GetPorts_44::distinguishedSortOutputs()
{
	_out_4b->sort( std::ptr_fun( YPosCmp_caster< Udm::Object, UMLModelTransformer::Out>));
	NeitherPredicate< Udm::Object> neitherPredicateUMLModelTransformer__Out_6d( std::ptr_fun( YPosCmp_caster< Udm::Object, UMLModelTransformer::Out>));
	_out_4b->unique( neitherPredicateUMLModelTransformer__Out_6d);
	_in_4c->sort( std::ptr_fun( YPosCmp_caster< Udm::Object, UMLModelTransformer::In>));
	NeitherPredicate< Udm::Object> neitherPredicateUMLModelTransformer__In_6e( std::ptr_fun( YPosCmp_caster< Udm::Object, UMLModelTransformer::In>));
	_in_4c->unique( neitherPredicateUMLModelTransformer__In_6e);
	unsigned int size_of_ins= _in_4c->size();
	unsigned int size_of_outs= _out_4b->size();
	unsigned int min_size= std::min( size_of_ins, size_of_outs);
	deleteFrom( _in_4c, min_size);
	deleteFrom( _out_4b, min_size);
}

void GetRules_75::operator()( const Packets_t& compoundRules_76, Packets_t& froms_78, Packets_t& tos_79)
{
#ifdef PRINT_INFO
	std::cout << "GetRules_75" << std::endl;
#endif
	_from_7a= &froms_78;
	_to_7b= &tos_79;
	processInputPackets( compoundRules_76);
}

bool GetRules_75::isInputUnique( const Udm::Object& compoundRule_80)
{
	bool isUnique= true;
	for( Packets_t::const_iterator itCompoundRule_82= _compoundRule_7c.begin(); itCompoundRule_82!= _compoundRule_7c.end(); ++itCompoundRule_82)
	{
		if( ( *itCompoundRule_82== compoundRule_80))
		{
			isUnique= false;
			break;
		}
	}
	if( isUnique)
		_compoundRule_7c.push_back( compoundRule_80);
	return isUnique;
}

bool GetRules_75::isGuardTrue( const UMLModelTransformer::CompoundRule& CompoundRule, const UMLModelTransformer::Expression& From, const UMLModelTransformer::Expression& To)
{
	bool Gz_guard= false;
	return XPosCmp( From, To);;
	return Gz_guard;
}

void GetRules_75::processInputPackets( const Packets_t& compoundRules_76)
{
	for( Packets_t::const_iterator itCompoundRule_7d= compoundRules_76.begin(); itCompoundRule_7d!= compoundRules_76.end(); ++itCompoundRule_7d)
	{
		bool isUnique= isInputUnique( *itCompoundRule_7d);
		if( !isUnique)
			continue;
		bool isMatch= patternMatcher( *itCompoundRule_7d);
		if( isMatch)
			effector( );
		_matches.clear();
	}
}

bool GetRules_75::patternMatcher( const Udm::Object& compoundRule_7e)
{
	for( int i= 0; i< 1; ++i)
	{
		if( false== Uml::IsDerivedFrom( compoundRule_7e.type(), UMLModelTransformer::CompoundRule::meta))
			continue;
		UMLModelTransformer::CompoundRule compoundRule_83= UMLModelTransformer::CompoundRule::Cast( compoundRule_7e);
		set< UMLModelTransformer::Expression> tos_85= compoundRule_83.Expression_kind_children();
		for( set< UMLModelTransformer::Expression>::const_iterator itTo_86= tos_85.begin(); itTo_86!= tos_85.end(); ++itTo_86)
		{
			UMLModelTransformer::Expression currTo_87= *itTo_86;
			set< UMLModelTransformer::Expression> froms_88= compoundRule_83.Expression_kind_children();
			for( set< UMLModelTransformer::Expression>::const_iterator itFrom_89= froms_88.begin(); itFrom_89!= froms_88.end(); ++itFrom_89)
			{
				UMLModelTransformer::Expression currFrom_8a= *itFrom_89;
				// Composition identity check.
				if( ( currTo_87!= currFrom_8a))
				{
					Match currMatch;
					currMatch.compoundRule_8b= compoundRule_83;
					currMatch.from_8c= currFrom_8a;
					currMatch.to_8d= currTo_87;
					bool Gz_guard= isGuardTrue( currMatch.compoundRule_8b, currMatch.from_8c, currMatch.to_8d);
					if( true== Gz_guard)
						_matches.push_back( currMatch);
				}
			}
		}
	}
	return !_matches.empty();
}

void GetRules_75::effector()
{
	for( std::list< Match>::const_iterator itMatch= _matches.begin(); itMatch!= _matches.end(); ++itMatch)
	{
		Match currMatch= *itMatch;
		outputAppender( currMatch.from_8c, currMatch.to_8d);
	}
}

void GetRules_75::outputAppender( const UMLModelTransformer::Expression& from_91, const UMLModelTransformer::Expression& to_93)
{
	_from_7a->push_back( from_91);
	_to_7b->push_back( to_93);
}

