/* GenMyTransform.h generated on Fri Nov 04 00:47:42 2005
 */

#include <UdmBase.h>
#include <cint_string.h>
#include "UMLModelTransformer.h"

typedef std::list< Udm::Object> Packets_t;

// Forward declarations.
class TopBlock_0;
class GetCompoundRules_3;
class Block_1c;
class ConnectPorts_21;
class GetPorts_44;
class GetRules_75;

// Class declarations.
class TopBlock_0
{
public:
	void operator()( const Packets_t& ins_1);

protected:
	void callGetCompoundRules_95( const Packets_t& rootFolders_4);
	void callGetRules_97( const Packets_t& compoundRules_76);
	void callBlock_99( const Packets_t& ins_1d, const Packets_t& ins_1f);
};

class GetCompoundRules_3
{
public:
	void operator()( const Packets_t& rootFolders_4, Packets_t& compoundRules_6);

protected:
	bool isInputUnique( const Udm::Object& rootFolder_c);
	void processInputPackets( const Packets_t& rootFolders_4);
	bool patternMatcher( const Udm::Object& rootFolder_a);
	void effector();
	void outputAppender( const UMLModelTransformer::CompoundRule& compoundRule_1a);

private:
	Packets_t* _compoundRule_7;
	Packets_t _rootFolder_8;
	class Match
	{
	public:
		UMLModelTransformer::RootFolder rootFolder_17;
		UMLModelTransformer::Transformation transformation_18;
		UMLModelTransformer::CompoundRule compoundRule_19;
	};

	std::list< Match> _matches;
};

class Block_1c
{
public:
	void operator()( const Packets_t& ins_1d, const Packets_t& ins_1f);

protected:
	void callGetPorts_6f( const Packets_t& expressions_46, const Packets_t& expressions_48);
	void callConnectPorts_72( const Packets_t& outs_22, const Packets_t& ins_24);
};

class ConnectPorts_21
{
public:
	void operator()( const Packets_t& outs_22, const Packets_t& ins_24);

protected:
	bool isInputUnique( const Udm::Object& out_2a, const Udm::Object& in_33);
	void processInputPackets( const Packets_t& outs_22, const Packets_t& ins_24);
	bool patternMatcher( const Udm::Object& out_28, const Udm::Object& in_31);
	void effector();

private:
	Packets_t _out_26;
	Packets_t _in_2f;
	class Match
	{
	public:
		UMLModelTransformer::Out out_3e;
		UMLModelTransformer::Expression expression_3f;
		UMLModelTransformer::Expression expression_40;
		UMLModelTransformer::Expression expression_41;
		UMLModelTransformer::In in_42;
	};

	std::list< Match> _matches;
};

class GetPorts_44
{
public:
	void operator()( const Packets_t& expressions_46, const Packets_t& expressions_48, Packets_t& outs_45, Packets_t& ins_4a);

protected:
	bool isInputUnique( const Udm::Object& expression_51, const Udm::Object& expression_5a);
	void processInputPackets( const Packets_t& expressions_46, const Packets_t& expressions_48);
	bool patternMatcher( const Udm::Object& expression_4f, const Udm::Object& expression_58);
	void effector();
	void outputAppender( const UMLModelTransformer::Out& out_69, const UMLModelTransformer::In& in_6b);
	void distinguishedSortOutputs();

private:
	Packets_t* _out_4b;
	Packets_t* _in_4c;
	Packets_t _expression_4d;
	Packets_t _expression_56;
	class Match
	{
	public:
		UMLModelTransformer::Out out_65;
		UMLModelTransformer::Expression expression_66;
		UMLModelTransformer::Expression expression_67;
		UMLModelTransformer::In in_68;
	};

	std::list< Match> _matches;
};

class GetRules_75
{
public:
	void operator()( const Packets_t& compoundRules_76, Packets_t& froms_78, Packets_t& tos_79);

protected:
	bool isInputUnique( const Udm::Object& compoundRule_80);
	bool isGuardTrue( const UMLModelTransformer::CompoundRule& CompoundRule, const UMLModelTransformer::Expression& From, const UMLModelTransformer::Expression& To);
	void processInputPackets( const Packets_t& compoundRules_76);
	bool patternMatcher( const Udm::Object& compoundRule_7e);
	void effector();
	void outputAppender( const UMLModelTransformer::Expression& from_91, const UMLModelTransformer::Expression& to_93);

private:
	Packets_t* _from_7a;
	Packets_t* _to_7b;
	Packets_t _compoundRule_7c;
	class Match
	{
	public:
		UMLModelTransformer::CompoundRule compoundRule_8b;
		UMLModelTransformer::Expression from_8c;
		UMLModelTransformer::Expression to_8d;
	};

	std::list< Match> _matches;
};

