#ifndef EFFECTOR_H
#define EFFECTOR_H

#include "UmlExt.h"
#include "UdmBase.h"
#include "cint_string.h"
//#include "UdmInt.h"
//#include "UdmCInt.h"
#include "GeneralBackend.h"
#include "GReATTypes.h"

class Effector 
{
	typedef Udm::Object Object;
public:
	Effector(GR::RewritingRule *currRule,GeneralBackend *dataNetworkMap);
	~Effector();

	void executeRightSide(Match *match);
protected:
	bool getCompositionToBound(GR::ObjectWrapper &parentCO,GR::ObjectWrapper &childCO, Udm::Object::CompositionInfo &compInfo);
	void bindingConsequenceObject();
	void bindingRemainingObjectLinks();
	void executeCode();
	void reqDelete();
	void createRTT();

protected:
	GR::RewritingRule *boundRule;
	GeneralBackend* backendMap;
	Match *match;
};

#endif //EFFECTOR_H
