#if !defined(GRDebuggerHelp_h)
#define GRDebuggerHelp_h

namespace GRDI
{
const char intro[] =
"\
\n\
*********************************** \n\
                                    \n\
         GReAT Debugger             \n\
     ISIS Vanderbilt University     \n\
              2007                  \n\
                                    \n\
*********************************** \n\
";


const char help[] =
"\
help, or h \n\
  displays the list of recognized commands with a brief description. \n\
quit, or q \n\
  exits the debugger \n\
load [filename]  \n\
  loads a GReAT parameter file \n\
start \n\
  starts the execution of the debugged application. \n\
pause \n\
  pauses the execution of the debugged application. \n\
continue \n\
  continues the execution of the debugged application. \n\
run, or r \n\
  starts or continues of the execution the debugged application. \n\
stop  \n\
  quits the execution of the debugged application. \n\
print, or p \n\
  displays local variables.\n\
where, or w \n\
  dumps the context stack \n\
set location  \n\
  sets a breakpoint at location \n\
clear [location | all]  \n\
  removes breakpoints at location \n\
  command with no argument displays a list of all breakpoints currently set \n\
  command with all clears all breakpoints \n\
step, or s \n\
  advances execution to the next location whether it is \n\
  in the current context or a called method \n\
next, or n \n\
  advances execution to the next location in the current context \n\
step out, or so \n\
  advances execution to the next location in the caller context\n\
log [off | on] \n\
  switches on or off the logging \n\
";
};
#endif GRDebuggerHelp_h