#include <boost/thread/thread.hpp>
#include "GRDebuggerConsolFactory.h"
#include "GRDebuggerConsol.h"

boost::thread* GRDebuggerConsolFactory::m_thrd = 0;
//=====================================
GRDebuggerConsolAPI* GRDebuggerConsolFactory::create()
{
  return new GRDebuggerConsol();
}


//=====================================
struct ConsolThread
{
  GRDebuggerConsol*  m_api;
  
  ConsolThread(GRDebuggerConsol*  api) : m_api(api){}
  void operator()()
  {
    m_api->run();
  }
};
//=====================================
GRDebuggerConsolAPI* GRDebuggerConsolFactory::create_new_thread()
{
  ConsolThread fe(new GRDebuggerConsol());
  
  GRDebuggerConsolFactory::m_thrd = new boost::thread(fe);
  return fe.m_api;
}
//=====================================
void GRDebuggerConsolFactory::join()
{
  if (GRDebuggerConsolFactory::m_thrd)
  {
    GRDebuggerConsolFactory::m_thrd->join(); 
    delete GRDebuggerConsolFactory::m_thrd, GRDebuggerConsolFactory::m_thrd = 0;
  }
}
