#if !defined(GRDebuggeeAPI_h)
#define GRDebuggeeAPI_h

#include <string>

namespace GRDI
{
  class IGRDBackEnd;
};

//======================================

class GRDebuggeeAPI
{
public:

  virtual ~GRDebuggeeAPI() {}

  virtual void setWD(const std::string& wd) = 0;
  virtual void load(const std::string& pfn) = 0;
  virtual void run() = 0;
  virtual void wait_up() = 0;
  virtual void stop() = 0;
  virtual void setGRDBackEnd(GRDI::IGRDBackEnd*  back) = 0;
};

#endif //GRDebuggeeAPI_h
